
; XXX stretch OC2 RX period so that it ALWAYS gets one A/D result
; but rarely two
;
; ADCTL0 := 008C
;	RES10=1 10-bit
;	PRS=12 (decimal)
;		divisor 13 for ADCLK
;	STS=0
;		part3 of sample time is 2 adc clocks, total 20 cyc (when 10-bit)
;       the undocumented 2 extra cycles from input mux change ?
;
;	16777216 Hz / 13 / 2 / 20 about 32264 Hz
;	2 conversions per one ANx conversion
;	2 ANx conversions per averaged sample for demodulator
;	16777216 Hz / 13 / 2 / 20 / 2 / 2 about 8066 Hz
;
; ADCTL1 := 0070
;	SCAN=1
;	MUL=1
;	S8CM=1
;
;	ADC rate to 1200baud: 8066 Hz / 1200 Hz = 0x504 / 0xBF
;    6.721641028
;    4033 and 600 would be precise
;    hmph. using the stolen constants anyway
;
	INCREMENT = 00BFh
	BITTIME   = 0504h

ADCTL1  equ 0F70Ch  ; reset and restart when written
ADCSTAT equ 0F70Fh  ; byte !!!
TCNT    equ 0F90Ah  ; word
TFLG1   equ 0F922h  ; byte
TOC2    equ 0F916h  ; word

;  one of the OC2 handlers is active at any time, wrt rx/tx

OC2_V   equ 008Ah

	;-----------------------------------------
	section .bankf
	align 1

	global adc_buf_insptr, adc_buf_remptr

adc_jump         ds.w 1 ; which adc channel is being waited for ?
adc_even_sample  ds.w 1 ; temporary AN0 or AN4 value
adc_buf_insptr   ds.w 1 ; MSByte and LSbit always 0, F:0000-00FE
adc_buf_remptr   ds.w 1 ; ...  buffer of 128 word sized samples

filter_1_tmp     ds.w 1
filter_3_prev    ds.w 1 ; previous output from last filter, MSbit tested

rx_tone_duration ds.w 1 ; how long pulse, in increments

	;-----------------------------------------
	section .inthand
	align 1

	; d,e,x,y,z are modified by instruction 'mac'

MACARONE	MACRO
	ldhi
	clrm
	dc.w 7BE2h, 7BE2h, 7BE2h, 7BE2h, 7BE2h ; mac -2, 2
	dc.w 7BE2h, 7BE2h, 7BE2h, 7BE2h, 7BE2h ; 11 of them
	dc.w 7BE2h
	tmer
	ENDM

	; called from pit interrupt, IPL lowered to 1. all regs available to use

	global afsk_rx_dsp

afsk_rx_dsp

	clrb
	tbyk
	comb              ; YK 0 and XK F
	tbxk

	ldd  # 0FF00h     ; samples in circular buffer, coefficients in list
	tdmsk
L0
	ldy  # afsk_coefficients   ; 3 sets of coeffs, in sequence

	ldx  adc_buf_remptr        ; F:0000, 256 bytes ring
	MACARONE
	bpl  L1
	nege
L1
	ste  filter_1_tmp          ; remember the result

	ldx  adc_buf_remptr        ; again for the another tone
	MACARONE
	bpl  L2
	nege
L2
	sube filter_1_tmp  ; which one fits better ?

	ste  0,x           ; stalking the end. buffer reused for 0/1
	MACARONE           ; filter 0/1 selection

	ldd  filter_3_prev ; old result for comparison. MSbit only interesting
	ste  filter_3_prev ; flip them

	lde  rx_tone_duration
	adde # INCREMENT     ; cumulate or rewind time XXX if carry its abort

	eord filter_3_prev   ; boiled down to output being negative or positive
	bpl  L3              ; only changing tone is interesting

	pshm k               ; cheaper to do here
	lbsr afsk_rx_edge    ; duration in E
	pulm k

	clre                 ; tone just changed, rewind time
L3
	ste  rx_tone_duration

	ldab adc_buf_remptr + 1
	addb # 2
	stab adc_buf_remptr + 1  ; only the LSByte += 2
	cmpb adc_buf_insptr + 1
	lbne L0
	rts

	;-----------------------------------------------------
	; rx filter coefficients, 3 sets of 11 words

	section .data
	align 1

afsk_coefficients

	; windowed, centered sin for low tone

	dc.w 1974, 1749, -311, -2835, -2891
	dc.w 45
	dc.w 3005, 2838, 219, -1796, -1958

	; for high tone (in reverse and more gain)

	dc.w 2113, 718, -3273, -522, 4533
	dc.w 7
	dc.w -4524, 5136, 3285, -711, -2103

	; window for bitcell

	dc.w -1334, -1366, 429, 4375, 8598
	dc.w 10427
	dc.w 8598, 4375, 429, -1366, -1334

	section .data  ; ------------------------------------------
	align 1

rx_shifter  dc.b 80h   ; marker in MSbit
tx_onebits  dc.b 0     ; contiguous onebits

	section .bss   ; ------------------------------------------
	align 1

phase_inc   ds.w 1     ; 1200 Hz. will flip back and forth with 2200 Hz
phase_acc   ds.w 1     ; cumulator for tone
tx_bit_acc  ds.w 1     ; cumulator for bit duration
tx_shifter  ds.w 1     ; MSByte contains marker, LSByte data
tx_list     ds.w 1     ; unfinished transmit frames
tx_ptr      ds.w 1     ; bytes in current frame
tx_endptr   ds.w 1     ; last plus one
rx_buf      ds.w 1     ; if NULL, out of sync

	global _afsk_dcd_h, _afsk_dcd_l

_afsk_dcd_h ds.w 1
_afsk_dcd_l ds.w 1


	section .inthand ; --------------------------------------------
	align 1

;---------------------------------------------------------
;
;  ADC speedbuffer
;

OC2_afsk_rx           ; just sample collector really

	pshm d,x,k

	ldab # 0FFh
	tbek
	tbxk               ; EXT and IX to registers (and internal RAM)

	ldx  adc_jump
	jmp  0,x           ; word offset from 0:0  into one of adc_0 ... adc_6

adc_out

	ldd  # 80h        ; prep for next compare, half slower than in modulator
	addd TCNT         ; restart from _now_, not from last OC2
	std  TOC2         ; ADC was emptied, no rush
	bclr TFLG1, # 10h ; clear OC2F

	stx  adc_jump

	pulm d,x,k
	rti


ODD_SAMPLE	MACRO
	asrd                    ; halve
	addd adc_even_sample    ; add previous reading
	ldx  adc_buf_insptr     ; sample pointer
	std  0,x                ; into samplebuffer at F:0000-00FE
	xgdx                    ; shufflety
	addb # 2                ; bump by a word
	stab adc_buf_insptr + 1 ; sample "pointer" updated
	ENDM

EVEN_SAMPLE	MACRO
	asrd
	std  adc_even_sample
	ENDM

adc_0
	brclr ADCSTAT, # 01h, adc_out
	ldd  0F720h         ; save LJRR0 temporarily
	EVEN_SAMPLE
	ldx  # adc_2
adc_2
	brclr ADCSTAT, # 04h, adc_out
	ldd  0F724h         ; get LJRR2
	ODD_SAMPLE
	ldx  # adc_4
adc_4
	brclr ADCSTAT, # 10h, adc_out
	ldd  0F728h         ; save LJRR4 temporarily
	EVEN_SAMPLE
	ldx  # adc_6
adc_6
	brclr ADCSTAT, # 40h, adc_out
	ldd  0F72Ch         ; get LJRR6
	ODD_SAMPLE
	ldx  # adc_0
	bra  adc_0



	; the entrypoint is in the middle, scroll down a page or two.

flag_maybe

	cpe  # BITTIME * 7
	bcc  drop_sync      ; more than flag really. abort

	rolw _afsk_dcd_l    ; shift in one more 1, carry set from compare above
	rolw _afsk_dcd_h    ; 32 bits

	ldx  rx_buf         ; will be used shortly below
	beq  first_flag     ; not yet sync, grab a buffer.

	ldab rx_shifter     ; discard, if fractional bytes in packet
	cmpb #40h           ; flag started with a zerobit, 80 to 40
	bne  rewind
	ldd  2, x           ; length of buffer
	cpd  #15+2          ; .lt. AXMINLEN + CRC
	bcs  rewind
	cpd  #512+1         ; .gt. RXPACLEN (sizeof buf.data)
	bcc  rewind

	clrw 0, x           ; will become last in rxq
	xgdx                ; D -> buffer

	ldx  #_rxq          ; find end of ready q. simpleton. short list.
	bra  test_if_last
walk
	ldx  0, x
test_if_last
	tstw 0, x
	bne  walk
	std  0, x           ; append into q

	clrw rx_buf         ; no current buffer

	; then, grab a new one for us

first_flag

	ldx  _rxq_free
	beq  done           ; no buffers

	stx  rx_buf         ; spanking new one
	ldd  0, x           ; next buf (if any)
	std  _rxq_free      ; ... into head of free list

rewind
	clrw 2, x           ; zero length of our buffer

	ldab #80h           ; empty marker
	stab rx_shifter     ; nothing here

	rts                 ; continue dsp with next sample

drop_sync

	clrw _afsk_dcd_l    ; no DCD
	clrw _afsk_dcd_h    ; 32 bits

	ldx  rx_buf
	beq  done

	clrw rx_buf         ; no current buffer
	ldd  _rxq_free      ; old first
	std  0, x           ; second in new list
	stx  _rxq_free      ; new first one
done
	rts                 ; continue dsp with next sample


	; called from dsp, pit, IPL is 1. no need to save anything

afsk_rx_edge            ; called from afsk_rx_dsp, E has pulse duration

	clrb                ; external RAM
	tbek
	tbxk                ; for EK and X

	sube # BITTIME / 2  ; round it and turn to time of "1"
	bcs  drop_sync      ; less than half a bit

	cpe  # BITTIME * 6
	lbcc flag_maybe     ; a flag or an abort

	rolw _afsk_dcd_l    ; shift in one more 1, carry set from compare above
	rolw _afsk_dcd_h    ; 32 bits

	ldx  rx_buf         ; will be used shortly below
	beq  done           ; not in sync, wait for a flag

	cpe  # BITTIME * 1
	bcs  add_0           ;
	cpe  # BITTIME * 2
	bcs  add_10          ;
	cpe  # BITTIME * 3
	bcs  add_110         ;
	cpe  # BITTIME * 4
	bcs  add_1110        ;
	cpe  # BITTIME * 5
	bcs  add_11110       ;

	bsr  add_1           ; must be 11111 then
	bsr  add_1
	bsr  add_1
	bsr  add_1

	; fall thru to the last add

add_1
	orp  #0100h         ; set carry
	ror  rx_shifter     ; insert 1-bit
	bcs  bump           ; marker past 8 bits ?
	rts
bump
	ldd  2, x           ; length
	incw 2, x
	andd #512-1         ; XXX RXPACLEN
	adx                 ; buf in IX ruined, but only one bump per pulse
	ldaa rx_shifter
	staa 4, x           ; one more data byte
	ldaa #80h           ; empty marker
	staa rx_shifter     ; nothing here
	rts

add_11110
	bsr  add_1
add_1110
	bsr  add_1
add_110
	bsr  add_1
add_10
	bsr  add_1
add_0
	lsr  rx_shifter     ; insert 0-bit
	bcs  bump           ; return via bump, if marker shows got 8 bits
	rts                 ; less than 8, just return


; -----------------------------------------------
;
;  Modulator - quagmire of similar handlers
;


TX_PROLOGUE	MACRO

	pshm d,x,k

	ENDM

TX_EXIT	MACRO

	pulm d,x,k
	rti

	ENDM

	; flip tone with a nice trick

TX_TONE_CHANGE	MACRO

	ldd  phase_inc     ; swap phase increment 1200 <-> 2200 Hz
	eord #12448        ; (4 * 1200) ^ (4 * 2200)
	std  phase_inc     ; tone changed

	ENDM


	;--------------------------------

OC2_afsk_tx_idle

	TX_PROLOGUE
	bsr  tx_chores
	bcc  tx_out        ; not yet another bit

	TX_TONE_CHANGE

	TX_EXIT


	;--------------------------------
OC2_afsk_tx_flag

	TX_PROLOGUE
	bsr  tx_chores
	bcc  tx_out        ; not yet another bit

	lsrw tx_shifter    ; next bit into carry, marker down
	bcs  tx_out        ; 1-bit is no change in tone in the middle of the flag

	TX_TONE_CHANGE

	tst  tx_shifter    ; byte access to marker
	bne  tx_out        ; if it was the first 0 in flag, not the last bit.

	ldx  tx_list       ; next in list of frames
	beq  tx_finished   ; none left

	ldaa #80h          ; marker for full 8 bits in shifter
	ldab 4, x          ; first byte of data[]
	std  tx_shifter
	ldd  2, x          ; length
	aix  #4
	stx  tx_ptr        ; data[]
	adx
	stx  tx_endptr     ; one past last byte

	clrw tx_onebits    ; ready to stuff bits

	ldd  # OC2_afsk_tx_data
	std  OC2_V         ; change vector

	TX_EXIT

tx_finished

	ldd  # OC2_afsk_tx_last ; flush the last bit out
	std  OC2_V              ; change vector

tx_out
	TX_EXIT


	;--------------------------------
OC2_tonegen

	TX_PROLOGUE
	bsr  tx_chores

	TX_EXIT

	;--------------------------------
	; little bit too large for a macro XXX

tx_chores

	clrb
	tbek
	tbxk                 ; EK, XK 0

	ldd  phase_inc       ; step DDS
	addd phase_acc
	std  phase_acc
	tab                  ; divide D
	clra                 ; by 256
	xgdx                 ; index with IX
	ldab pwm_sin, x      ; from sine[256]. must reside below 0x8000

	ldx  # 0             ; wrap-access the registers

	stab 0F926h,x        ; PWM update to PWMA

	ldd  # 40h           ; interval - 16.384 kHz
	addd 0F916h,x        ; TOC2
	std  0F916h,x        ; prep for next compare
	bclr 0F922h,x, # 10h ; clear OC2F from TFLG1

    ldd  # 4 * 1200      ; 1200 baud
	addd tx_bit_acc
	std  tx_bit_acc

	rts                  ; carry if on bit boundary

	;--------------------------------
OC2_afsk_tx_last

	TX_PROLOGUE
	bsr  tx_chores
	bcc  tx_out        ; not yet another bit

	TX_TONE_CHANGE

	ldd  # OC2_afsk_tx_idle
	std  OC2_V         ; change vector

	TX_EXIT

	;--------------------------------
OC2_afsk_tx_data

	TX_PROLOGUE
	bsr  tx_chores
	bcc  tx_out        ; not yet another bit

	ldaa tx_onebits    ; this many so far
	inca               ; assume 1

	lsrw tx_shifter    ; next bit into carry, marker down
	bcs  no_change     ; 1-bit is no change in tone

	TX_TONE_CHANGE

	clra               ; no ones now

no_change

	cmpa #5
	beq  add_stuff     ; go and force a 0
	staa tx_onebits    ; remember if 0 ...4

	tst  tx_shifter    ; byte access to marker in MSByte
	bne  tx_out_too    ; more bits to come from this byte

	ldx  tx_ptr
	aix  #1
	cpx  tx_endptr
	beq  send_flag     ; no more bytes in this frame

	stx  tx_ptr
	ldaa #80h          ; marker for 8 valid bits
	ldab 0, x          ; another byte from data[]
	std  tx_shifter

tx_out_too
	TX_EXIT

add_stuff

	aslw tx_shifter    ; next one is an additional 0

	TX_EXIT

send_flag

	ldd  #807Eh        ; marker and flag
	std  tx_shifter

	ldd  # OC2_afsk_tx_flag
	std  OC2_V         ; change vector to send one unstuffed byte

	ldx  tx_list       ; frame that was just sent
	ldd  0, x
	std  tx_list       ; one less frame in list now

	ldd  _txq_free     ; release the buffer
	std  0,x
	stx  _txq_free     ; txq_relse must protect itself

	TX_EXIT




	section .text ; ---------------------------------------------------
	align 1

	;---------------------------------------
	global _tone_generator

_tone_generator

	ste  phase_inc           ; argument, 4 * Hz

	ldd  # OC2_tonegen
	std  OC2_V               ; change vector

	; XXX offset TOC2 from PWMCNT for best snr

	rts

	;---------------------------------------
	global _afsk_tx_idle

_afsk_tx_idle

	clrw tx_list

	ldd  # 4 * 1200          ; 1200 Hz
	std  phase_inc           ; in case was fouled by tonegen

	ldd  # OC2_afsk_tx_idle
	std  OC2_V               ; change vector

	; XXX offset TOC2 from PWMCNT for best snr

	rts

	;---------------------------------------
	global _afsk_tx_go

_afsk_tx_go

	ste  tx_list             ; argument, txq list

	ldd  #807Eh              ; marker and flag
	std  tx_shifter

	ldd  # OC2_afsk_tx_flag
	std  OC2_V               ; change vector

	rts

	;---------------------------------------
	global _afsk_tx_going

_afsk_tx_going

	ldd  # OC2_afsk_tx_idle
	subd OC2_V               ; D is zero if all sent

	rts


	;---------------------------------------
	global _afsk_rx_on

_afsk_rx_on

	pshm k,ccr
	orp  # 000E0h

	clrb
	tbek               ; external RAM

	ldd  # OC2_afsk_rx
	std  OC2_V         ; change vector

	clrw _afsk_dcd_l   ; no DCD at this point
	clrw _afsk_dcd_h   ; 32 bits

	ldab # 0FFh
	tbek               ; SFRs and internal ram

	clrw adc_buf_insptr  ; clear adc buffering
	clrw adc_buf_remptr

	ldd  # 1
	std  demod_lock    ; unlock it

	ldd  # adc_0
	std  adc_jump      ; rewind the channel we want to read next

	ldd  # 0070h       ; scan, multiple, 8 channels. AN0...7
	std  ADCTL1        ; reset and restart when written

	pulm k,ccr
	rts

	;---------------------------------------
	section .data

	global pwm_sin

pwm_sin

	dc.b 080h,083h,086h,089h,08ch,08fh,092h,095h,098h,09bh,09eh,0a2h,0a5h,0a7h,0aah,0adh
	dc.b 0b0h,0b3h,0b6h,0b9h,0bch,0beh,0c1h,0c4h,0c6h,0c9h,0cbh,0ceh,0d0h,0d3h,0d5h,0d7h
	dc.b 0dah,0dch,0deh,0e0h,0e2h,0e4h,0e6h,0e8h,0eah,0ebh,0edh,0eeh,0f0h,0f1h,0f3h,0f4h
	dc.b 0f5h,0f6h,0f8h,0f9h,0fah,0fah,0fbh,0fch,0fdh,0fdh,0feh,0feh,0feh,0ffh,0ffh,0ffh
	dc.b 0ffh,0ffh,0ffh,0ffh,0feh,0feh,0feh,0fdh,0fdh,0fch,0fbh,0fah,0fah,0f9h,0f8h,0f6h
	dc.b 0f5h,0f4h,0f3h,0f1h,0f0h,0eeh,0edh,0ebh,0eah,0e8h,0e6h,0e4h,0e2h,0e0h,0deh,0dch
	dc.b 0dah,0d7h,0d5h,0d3h,0d0h,0ceh,0cbh,0c9h,0c6h,0c4h,0c1h,0beh,0bch,0b9h,0b6h,0b3h
	dc.b 0b0h,0adh,0aah,0a7h,0a5h,0a2h,09eh,09bh,098h,095h,092h,08fh,08ch,089h,086h,083h
	dc.b 07fh,07ch,079h,076h,073h,070h,06dh,06ah,067h,064h,061h,05dh,05ah,058h,055h,052h
	dc.b 04fh,04ch,049h,046h,043h,041h,03eh,03bh,039h,036h,034h,031h,02fh,02ch,02ah,028h
	dc.b 025h,023h,021h,01fh,01dh,01bh,019h,017h,015h,014h,012h,011h,00fh,00eh,00ch,00bh
	dc.b 00ah,009h,007h,006h,005h,005h,004h,003h,002h,002h,001h,001h,001h,000h,000h,000h
	dc.b 000h,000h,000h,000h,001h,001h,001h,002h,002h,003h,004h,005h,005h,006h,007h,009h
	dc.b 00ah,00bh,00ch,00eh,00fh,011h,012h,014h,015h,017h,019h,01bh,01dh,01fh,021h,023h
	dc.b 025h,028h,02ah,02ch,02fh,031h,034h,036h,039h,03bh,03eh,041h,043h,046h,049h,04ch
	dc.b 04fh,052h,055h,058h,05ah,05dh,061h,064h,067h,06ah,06dh,070h,073h,076h,079h,07ch

	;---------------------------------------
	end

