
typedef unsigned char  bool;
typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;

#define FALSE (0)
#define TRUE  (1)
#define NULL  ((void *) 0)

#define INTEREST_IN_CFG 2
#include "hamdr_cfg.h"

#define NUM_PARM (sizeof(cfg_general) / sizeof(*cfg_general))

static struct cfg cfg;

main(int argc, char **argv)
{
	int html = (argc > 1) && !strcmp(argv[1], "html");

	int i, j, k, n;
	char c, *cp;
	struct cfgparm *p;

	for (p = cfg_general; p < cfg_general + NUM_PARM; ++p) {

		printf(html ? "<h3>%s</h3>\n\t<blockquote>\n" : "%s\n",
			p->name);

		if (p->group != (byte) ~0) {
			printf("\t");
			cp = "";

			if (p->group & (1 << PERSONALITY_TRACKER)) {
				printf("%sTracker", cp);
				cp = ", ";
			}
			if (p->group & (1 << PERSONALITY_KISS)) {
				printf("%sKISS", cp);
				cp = ", ";
			}
			if (p->group & (1 << PERSONALITY_PEATER)) {
				printf("%sDigipeater", cp);
				cp = ", ";
			}
			if (p->group & (1 << PERSONALITY_VOICE)) {
				printf("%sVoice", cp);
				cp = ", ";
			}
			if (p->group & (1 << PERSONALITY_SCANNER)) {
				printf("%sScanner", cp);
				cp = ", ";
			}

			printf(html ? "<br>\n" : "\n");
		}

		switch (p->type) {
		default:
			abort();
			break;

		case CFG_BOOL:
			printf(html ? "\t<ul><li>%s%s</li><li>%s%s</li></ul>\n"
			            : "\t\t%s%s\n\t\t%s%s\n",
				"on", (p->defval ? " DEFAULT" : ""),
				"off", (p->defval ? "" : " DEFAULT"));
			break;

		case CFG_TAB:
			printf(html ? "\t<ul>\n" : "");
			for (j = 0; p->optlist[j]; ++j)
				printf(html ? "\t\t<li>%s%s</li>\n" : "\t\t%s%s\n",
					p->optlist[j], (j == p->defval) ? " DEFAULT" : "");

			printf(html ? "\t</ul>\n" : "");
			break;

		case CFG_APRSYM:
			printf(html ? "\t<ul><li>%d characters</li></ul>\n"
			            : "\t\t%d characters\n",
				2);
			break;

		case CFG_STR:
			printf(html ? "\t<ul><li>%d characters</li></ul>\n"
			            : "\t\t%d characters\n",
				p->size - 1);
			break;

		case CFG_WORD:
			printf(html ? "\t<ul><li>0...65535, DEFAULT %d</li></ul>\n"
			            : "\t\t0...65535, DEFAULT %d\n",
				p->defval);
			break;

		case CFG_BYTE:
			printf(html ? "\t<ul><li>0...255, DEFAULT %d</li></ul>\n"
			            : "\t\t0...255, DEFAULT %d\n",
				p->defval);
			break;

		case CFG_FREQ:
			printf(html ? "\t<ul><li>kHz, DEFAULT %d</li></ul>\n"
			            : "\t\tkHz, DEFAULT %d\n",
				p->defval);
			break;
		}
		printf("\n\t%s\n", p->info);

		printf(html ? "\t</blockquote>\n\n" : "\n");
	}
	exit(0);
}

