;
;  Sundry space hoggers here, to conserve the precious RAM.
;

	section .rodata   ;----------------------------------------
	align 1

	; could skip the first few values

powers
	dc.w 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2
	dc.w 3, 3, 3, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6, 7, 7, 8
	dc.w 9, 9, 10, 11, 12, 13, 14, 15, 16, 17, 19
	dc.w 20, 22, 23, 25, 27, 30, 32, 34, 37, 40, 43, 47
	dc.w 51, 55, 59, 64, 69, 74, 80, 87, 94
	dc.w 101, 109, 118, 128, 138, 149, 161, 174, 187
	dc.w 202, 219, 236, 255, 275, 297, 321, 347, 375
	dc.w 405, 437, 472, 510, 550, 595, 642, 693, 749, 809, 874, 943
	dc.w 1019
	dc.w 65535 ; sentinel

	section .text
	align 1

log1_08
	pshm k

	ldd  # __text_page
	tbxk
	ldx  # powers - 2
L1
	aix  #+2
	cpe  0,x
	bhi  L1                 ; until exact or past

	xgdx
	subd # powers           ; remove base
	lsrd                    ; offset to index

	pulm k
	rts

	global _compressed_knots
	global _compressed_range

_compressed_range           ; (word kilometers_in_E)

	ldd  # 40722            ; scale to miles, will not overflow.
	emul                    ; ED = E * D, E nicely stays in place
	rold                    ; silly facism with rounding
	adce # 0
	lsre                    ; halve it, log of twomiles
	bra  log1_08            ; take log

_compressed_knots           ; (word knots_in_E)

	adde # 1                ; add one. assume input never 65535 knots
	bra  log1_08            ; take log

	section .rodata   ;----------------------------------------
	align 1

eight_bit_sin_from_abs_degrees
	dc.b   0,  4,  8, 13, 17, 22, 26, 31, 35, 40
	dc.b  44, 48, 53, 57, 61, 66, 70, 74, 79, 83
	dc.b  87, 91, 95,100,104,108,112,116,120,124
	dc.b 127,131,135,139,143,146,150,154,157,161
	dc.b 164,167,171,174,177,181,184,187,190,193
	dc.b 196,198,201,204,207,209,212,214,217,219
	dc.b 221,223,226,228,230,232,233,235,237,238
	dc.b 240,242,243,244,246,247,248,249,250,251
	dc.b 252,252,253,254,254,255,255,255,255,255
	dc.b 255,255,255,255,255,255,254,254,253,252
	dc.b 252,251,250,249,248,247,246,244,243,242
	dc.b 240,238,237,235,233,232,230,228,226,223
	dc.b 221,219,217,214,212,209,207,204,201,198
	dc.b 196,193,190,187,184,181,177,174,171,167
	dc.b 164,161,157,154,150,146,143,139,135,131
	dc.b 127,124,120,116,112,108,104,100, 95, 91
	dc.b  87, 83, 79, 74, 70, 66, 61, 57, 53, 48
	dc.b  44, 40, 35, 31, 26, 22, 17, 13,  8,  4
	dc.b   0

	TAB = 009h
	NL  = 00Ah
helptext
	dc.b NL
	dc.b 'nop',            TAB,'nothing',                         NL
	dc.b 'version',        TAB,'software version',                NL
	dc.b 'reboot',         TAB,'warm reboot',                     NL
	dc.b 'restart',        TAB,'less than a reboot',              NL
	dc.b 'factorydefaults',TAB,'reset parameters',                NL
	dc.b 'profile n',      TAB,'select profile number n',         NL
	dc.b 'channel n',      TAB,'show channel n (or all)',         NL
	dc.b 'channel n r',    TAB,'channel n is simplex at r kHz',   NL
	dc.b 'channel n r t',  TAB,'channel n is duplex r/t',         NL
	dc.b 'remote call',    TAB,'configure another set via radio', NL
	dc.b 'disp',           TAB,'all parameters',                  NL
	dc.b 'disp tkdvs',     TAB,'select subset of parameters',     NL
	dc.b 'wpt_stash',      TAB,'at most 100 latest waypoints',    NL
	dc.b 'stat',           TAB,'some input status',               NL
	dc.b 'perm',           TAB,'nonvolatile save',                NL
	dc.b                   TAB,'changes are temporary otherwise', NL
	dc.b 'help foo',       TAB,'describe parameter foo',          NL
	dc.b 'foo',            TAB,'show parameter foo',              NL
	dc.b 'foo bar',        TAB,'set parameter foo to "bar"',      NL
	dc.b 'set foo',        TAB,'clear parameter foo',             NL
	dc.b NL
	dc.b 0

	section .text
	align 1

lookup
	pshm k

	ldd  # __text_page
	tbxk
	ldab e, x
	clra                 ; zeroextend for word return

	pulm k
	rts

	global _helptext
	global _eight_bit_sin_from_abs_degrees

_helptext                             ; (word index_in_E)

	ldx  # helptext
	bra  lookup

_eight_bit_sin_from_abs_degrees       ; (word absdeg_in_E)

	ldx  # eight_bit_sin_from_abs_degrees
	bra  lookup

	section .rodata   ;----------------------------------------

SYMBOL	MACRO	c, n

	dc.b c
	dc.b n
	dc.b 0

	ENDM

	; name length must be 13 or less

aprs_symbols

	SYMBOL 021h, 'police'
	SYMBOL '#','digi'
	SYMBOL '$','phone'
	SYMBOL 027h,'aircraft'
	SYMBOL 027h,'aeroplane'
	SYMBOL '*','snowmobile'
	SYMBOL '+','redcross'
	SYMBOL '-','house'
	SYMBOL '.','x'
	SYMBOL '/','dot'
	SYMBOL '0','0'
	SYMBOL '1','1
	SYMBOL '2','2'
	SYMBOL '3','3'
	SYMBOL '4','4'
	SYMBOL '5','5'
	SYMBOL '6','6'
	SYMBOL '7','7'
	SYMBOL '8','8'
	SYMBOL '9','9'
	SYMBOL ':','fire'
	SYMBOL 03Bh, 'camp'
	SYMBOL '<','motorcycle'
	SYMBOL '<','bike'
	SYMBOL '>','car'
	SYMBOL 'A','aid'
	SYMBOL 'E','eye'
	SYMBOL 'H','hotel'
	SYMBOL 'K','school'
	SYMBOL 'O','balloon'
	SYMBOL 'P','police'
	SYMBOL 'R','rv'
	SYMBOL 'U','bus'
	SYMBOL 'X','helicopter'
	SYMBOL 'Y','yacht'
	SYMBOL '[','jogger'
	SYMBOL 05Ch, 'triangle'
	SYMBOL '_','wx'
	SYMBOL 'a','ambulance'
	SYMBOL 'b','bicycle'
	SYMBOL 'd','garage'
	SYMBOL 'd','firedep'
	SYMBOL 'f','firetruck'
	SYMBOL 'g','glider'
	SYMBOL 'h','hospital'
	SYMBOL 'j','jeep'
	SYMBOL 'k','truck'
	SYMBOL 'n','node'
	SYMBOL 'o','emergencyop'
	SYMBOL 'o','eoc'
	SYMBOL 'p','rover'
	SYMBOL 'p','puppy'
	SYMBOL 'r','antenna'
	SYMBOL 's','ship'
	SYMBOL 's','powerboat'
	SYMBOL 't','truckstop'
	SYMBOL 'u','truck'
	SYMBOL 'v','van'
	SYMBOL 'w','water'
	SYMBOL 'y','yagi'

aprs_alternate_symbols

	SYMBOL '!','emergency'
	SYMBOL '#','greendigi'
	SYMBOL 027h, 'crash'
	SYMBOL '+','church'
	SYMBOL '-','hfhouse'
	SYMBOL '9','gas'
	SYMBOL 03Bh, 'picnic'
	SYMBOL '?','info'
	SYMBOL 'A','box'
	SYMBOL 'L','lighthouse'
	SYMBOL 'N','navigation'
	SYMBOL 'P','parking'
	SYMBOL 'R','restaurant'
	SYMBOL 'X','pharmacy'

aprs_symbols_end

	section .text
	align 1

	global _next_aprs_symbol

_next_aprs_symbol          ; (word offset_in_E, byte *buf_in_D)

	pshm k

	xgdy                   ; IY to result buffer (buf[16] is ok)

	ldd  # __text_page
	tbxk
	ldx  # aprs_symbols
	aex                    ; IX to current offset at codelist

	clrd                   ; assume no more
	cpx  # aprs_symbols_end
	bcc  L5                ; no more

	ldab # '/'             ; assume still in primary
	cpx  # aprs_alternate_symbols
	bcs  L3
	ldab # 5Ch             ; prepend \ instead
L3
	stab 0, y              ; table id
	aiy  #+1
	clre
	ldab e, x
	stab e, y              ; symbol code
L4
	adde #+1
	ldab e, x
	stab e, y              ; one more character
	bne  L4                ; until at \0

	adde #+1               ; index over \0 to next code
	aex                    ; pointer to next code - will not overflow bank
	xgdx                   ; return value always in D
	subd # aprs_symbols    ; turn pointer into next offset
L5
	pulm k
	rts

	section .data  ; --- _DATA_, NOT rodata, such a small table -------------
	align 1

overlayable
	dc.b '#&0>AW^_acinsuvz'
overlayablend

	section .text
	align 1

	global _is_valid_symbol
	global _is_valid_symbol_with_compression

_is_valid_symbol

	xgde                        ; B from tab_in_E
	cmpb # '/'
	beq  test_normal_symbol
	cmpb # 5Ch
	beq  test_normal_symbol

	cmpb # '0'
	bcs  not_valid
	cmpb # '9'
	bls  test_overlaid_symbol
	cmpb # 'A'
	bcs  not_valid
	cmpb # 'Z'
	bls  test_overlaid_symbol
	bra  not_valid

_is_valid_symbol_with_compression

	xgde
	cmpb # '/'
	beq  test_normal_symbol
	cmpb # 5Ch
	beq  test_normal_symbol

	cmpb # 'A'
	bcs  not_valid
	cmpb # 'Z'
	bls  test_overlaid_symbol
	cmpb # 'a'
	bcs  not_valid
	cmpb # 'j'
	bls  test_overlaid_symbol
not_valid
	clrd
	rts                         ; D zero if invalid

test_normal_symbol

	xgde                        ; symbol_code_in_D back
	cmpb # '!'
	bcs  not_valid
	cmpb # '~'
	bhi  not_valid
is_valid
	rts                         ; D nonzero (sym returned back)

test_overlaid_symbol

	xgde                        ; symbol_code_in_D back
	ldx  # overlayable          ; why is this here, when table is in .data :/
L50
	cmpb 0,x
	beq  is_valid
	aix  #+1
	cpx  # overlayablend
	bne  L50
	bra  not_valid


	section .rodata   ;----------------------------------------
	align 1

	dc.w      0,    0  ; sentinel
altitab
	dc.w      1,  595  ; altitude meters and corresponding cs value
	dc.w      2,  942  ; interpolating this, error is less than 1%
	dc.w      3, 1144
	dc.w      4, 1288
	dc.w      5, 1400
	dc.w      6, 1491
	dc.w      8, 1635
	dc.w     10, 1747
	dc.w     12, 1838
	dc.w     15, 1950
	dc.w     19, 2068
	dc.w     23, 2164
	dc.w     28, 2262
	dc.w     34, 2360
	dc.w     41, 2453
	dc.w     49, 2542
	dc.w     59, 2635
	dc.w     71, 2728
	dc.w     85, 2818
	dc.w    101, 2905
	dc.w    120, 2991
	dc.w    143, 3079
	dc.w    170, 3165
	dc.w    202, 3251
	dc.w    240, 3338
	dc.w    286, 3425
	dc.w    340, 3512
	dc.w    404, 3598
	dc.w    480, 3685
	dc.w    571, 3772
	dc.w    679, 3858
	dc.w    807, 3945
	dc.w    959, 4031
	dc.w   1140, 4118
	dc.w   1354, 4204
	dc.w   1609, 4290
	dc.w   1912, 4376
	dc.w   2271, 4462
	dc.w   2698, 4549
	dc.w   3205, 4635
	dc.w   3807, 4721
	dc.w   4522, 4807
	dc.w   5371, 4893
	dc.w   6380, 4979
	dc.w   7578, 5066
	dc.w   9000, 5152
	dc.w  10689, 5238
	dc.w  12695, 5324
	dc.w  15078, 5410
	dc.w  17908, 5496
	dc.w  21269, 5582
	dc.w  25261, 5668
	dc.w  30002, 5754
	dc.w  35633, 5840
	dc.w  42320, 5926
	dc.w  50262, 6013
	dc.w  59694, 6099
	dc.w  65535, 6145 ; sentinel

	; dc.w  70896, 6185, XXX doing just words for now
	; dc.w  84200, 6271
	; dc.w 100000, 6357  XXX not much more data to handle 100 km


	section .text
	align 1

	global _compressed_altitude

_compressed_altitude            ; (long *altitude)

	pshm k
	xgex
	lde  0,x
	ldd  2,x           ; meters in ED

	tste               ; handle as signed 32 bits first
	bpl  L10           ; zero or positive is good
	clre
	clrd               ; floor is 0 meters, Z condition
L10
	beq  L11           ; less than 65536 meters is good
	clre
	ldd  # 65535       ; ceiling XXX special case this ?
L11
	tde                ; handle as unsigned 16 bits
	beq  L13           ; zero in, zero out

	ldy  # altitab - 4
	ldd  # __text_page
	tbyk
L12
	aiy  #+4           ; next checkpoint
	cpe  0,y           ; last value is FFFF, end safely
	bhi  L12           ; loop while our altitude is higher

	sube -4,y          ; our altitude - lower alt in E
	ldd  0,y
	subd -4,y          ; higher alt - lower alt
	xgdx               ; in IX
	ldd  2,y
	subd -2,y          ; higher value - lower value in D
	emul               ; ED = E * D
	ediv               ; IX = ED / IX
	xgdx
	addd -2,y          ; add lower value
L13
	pulm k
	rts

	end

